
#line 1 "lel_parser.rl"
#include "lel.hpp"
#include <fmt/core.h>
#include <iostream>

namespace lel {


#line 42 "lel_parser.rl"



#line 10 "lel_parser.cpp"
static const char _Parser_actions[] = {
	0, 1, 1, 1, 2, 1, 3, 1, 
	4, 1, 5, 1, 6, 1, 9, 1, 
	10, 1, 11, 1, 12, 2, 0, 7, 
	2, 0, 8, 2, 4, 1, 2, 4, 
	5
};

static const char _Parser_key_offsets[] = {
	0, 0, 4, 19, 21, 25, 37, 49, 
	54, 56, 59
};

static const char _Parser_trans_keys[] = {
	32, 91, 9, 13, 32, 40, 42, 46, 
	61, 94, 95, 9, 13, 60, 62, 65, 
	90, 97, 122, 48, 57, 41, 44, 48, 
	57, 40, 42, 46, 61, 94, 95, 60, 
	62, 65, 90, 97, 122, 32, 93, 95, 
	124, 9, 13, 48, 57, 65, 90, 97, 
	122, 32, 93, 124, 9, 13, 48, 57, 
	41, 48, 57, 32, 91, 9, 13, 0
};

static const char _Parser_single_lengths[] = {
	0, 2, 7, 0, 2, 6, 4, 3, 
	0, 1, 2
};

static const char _Parser_range_lengths[] = {
	0, 1, 4, 1, 1, 3, 4, 1, 
	1, 1, 1
};

static const char _Parser_index_offsets[] = {
	0, 0, 4, 16, 18, 22, 32, 41, 
	46, 48, 51
};

static const char _Parser_indicies[] = {
	0, 2, 0, 1, 3, 4, 5, 6, 
	8, 6, 9, 3, 7, 9, 9, 1, 
	10, 1, 11, 12, 13, 1, 4, 5, 
	6, 8, 6, 9, 7, 9, 9, 1, 
	14, 16, 15, 17, 14, 15, 15, 15, 
	1, 18, 19, 20, 18, 1, 21, 1, 
	22, 23, 1, 24, 2, 24, 1, 0
};

static const char _Parser_trans_targs[] = {
	1, 0, 2, 2, 3, 5, 5, 5, 
	5, 6, 4, 5, 8, 4, 7, 6, 
	10, 2, 7, 10, 2, 9, 5, 9, 
	10
};

static const char _Parser_trans_actions[] = {
	0, 0, 3, 0, 0, 13, 5, 11, 
	15, 19, 17, 21, 21, 0, 7, 0, 
	30, 27, 0, 9, 1, 17, 24, 0, 
	0
};

static const int Parser_start = 1;
static const int Parser_first_final = 10;
static const int Parser_error = 0;

static const int Parser_en_main = 1;


#line 45 "lel_parser.rl"

bool Parser::parse(std::string input) {
  reset();
  int cs = 0;
  const char *start = nullptr;
  const char *begin = input.data();
  const char *p = input.data();
  const char *pe = p + input.size();
  std::string tk;

  
#line 89 "lel_parser.cpp"
	{
	cs = Parser_start;
	}

#line 56 "lel_parser.rl"
  
#line 92 "lel_parser.cpp"
	{
	int _klen;
	unsigned int _trans;
	const char *_acts;
	unsigned int _nacts;
	const char *_keys;

	if ( p == pe )
		goto _test_eof;
	if ( cs == 0 )
		goto _out;
_resume:
	_keys = _Parser_trans_keys + _Parser_key_offsets[cs];
	_trans = _Parser_index_offsets[cs];

	_klen = _Parser_single_lengths[cs];
	if ( _klen > 0 ) {
		const char *_lower = _keys;
		const char *_mid;
		const char *_upper = _keys + _klen - 1;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + ((_upper-_lower) >> 1);
			if ( (*p) < *_mid )
				_upper = _mid - 1;
			else if ( (*p) > *_mid )
				_lower = _mid + 1;
			else {
				_trans += (unsigned int)(_mid - _keys);
				goto _match;
			}
		}
		_keys += _klen;
		_trans += _klen;
	}

	_klen = _Parser_range_lengths[cs];
	if ( _klen > 0 ) {
		const char *_lower = _keys;
		const char *_mid;
		const char *_upper = _keys + (_klen<<1) - 2;
		while (1) {
			if ( _upper < _lower )
				break;

			_mid = _lower + (((_upper-_lower) >> 1) & ~1);
			if ( (*p) < _mid[0] )
				_upper = _mid - 2;
			else if ( (*p) > _mid[1] )
				_lower = _mid + 2;
			else {
				_trans += (unsigned int)((_mid - _keys)>>1);
				goto _match;
			}
		}
		_trans += _klen;
	}

_match:
	_trans = _Parser_indicies[_trans];
	cs = _Parser_trans_targs[_trans];

	if ( _Parser_trans_actions[_trans] == 0 )
		goto _again;

	_acts = _Parser_actions + _Parser_trans_actions[_trans];
	_nacts = (unsigned int) *_acts++;
	while ( _nacts-- > 0 )
	{
		switch ( *_acts++ )
		{
	case 0:
#line 11 "lel_parser.rl"
	{tk = input.substr(start - begin, p - start); }
	break;
	case 1:
#line 13 "lel_parser.rl"
	{ }
	break;
	case 2:
#line 14 "lel_parser.rl"
	{ cur.row = rows; }
	break;
	case 3:
#line 15 "lel_parser.rl"
	{ cur.bottom = (*p) == '.'; }
	break;
	case 4:
#line 16 "lel_parser.rl"
	{ id(input.substr(start - begin, p - start)); }
	break;
	case 5:
#line 17 "lel_parser.rl"
	{
    rows++;
    columns = std::max(columns, cur.col);
    cur.col = 0;
  }
	break;
	case 6:
#line 22 "lel_parser.rl"
	{ cur.right = (*p) == '>'; }
	break;
	case 7:
#line 23 "lel_parser.rl"
	{cur.max_w = std::stoi(tk); }
	break;
	case 8:
#line 24 "lel_parser.rl"
	{ cur.max_h = std::stoi(tk); }
	break;
	case 9:
#line 25 "lel_parser.rl"
	{ cur.expand = true; }
	break;
	case 10:
#line 26 "lel_parser.rl"
	{ cur.center = true; }
	break;
	case 11:
#line 35 "lel_parser.rl"
	{ start = p; }
	break;
	case 12:
#line 38 "lel_parser.rl"
	{start = p;}
	break;
#line 208 "lel_parser.cpp"
		}
	}

_again:
	if ( cs == 0 )
		goto _out;
	if ( ++p != pe )
		goto _resume;
	_test_eof: {}
	_out: {}
	}

#line 57 "lel_parser.rl"

  bool good = pe - p == 0;
  if(good) {
    finalize();
  } else {
    fmt::println("error at");
    std::cout << p;
  }
  return good;
}

}
